﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BouyantPart : MonoBehaviour {

    private Waves waves;
    private Rigidbody rb;
    public float floatForce;
    public ParticleSystem splash;
    public WackyManAudio audio;

	void Start () {
        rb = GetComponent<Rigidbody>();
        waves = GameObject.FindObjectOfType<Waves>();
	}
	
	void FixedUpdate () {
        float waveHeight = waves.getWaveHeight(Mathf.RoundToInt(transform.position.x), Mathf.RoundToInt(transform.position.z));
        if (rb.position.y < waveHeight + 0.5f) {
            rb.AddForce(Vector3.up * floatForce, ForceMode.Acceleration);
            waves.onImpact((int)transform.position.x, (int)transform.position.z);
            
        }

        if (splash && (rb.position.y < waveHeight + 0.5f && rb.position.y > waveHeight - 3f))
        {
            if (audio)
                audio.playWaterSplash();

            splash.Play();
        }
        else if (splash)
        {
            splash.Stop();
        }
    }
}
