﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Waves : MonoBehaviour {

    private Mesh waveMesh;
    private Vector3[] waveVectors;
    public float waveSize1;
    public float waveSize2;
    private Material waveMaterial;
    public float waveSpeed1 = 1.5f;
    public float waveSpeed2 = 1f;

	void Start () {
        waveMaterial = GetComponent<Renderer>().material;
	}

	void Update () {
        waveMesh = GetComponent<MeshFilter>().mesh;
        waveVectors = waveMesh.vertices;

        for(int i = 0; i < waveVectors.Length; i++)
        {
            waveVectors[i].y = Mathf.Sin(Time.time * waveSpeed1 * waveVectors[i].x) * waveSize1 + Mathf.PerlinNoise(waveVectors[i].z, Time.time * waveSpeed2) * waveSize2;
        }

        waveMesh.vertices = waveVectors; 
        waveMesh.RecalculateNormals();

        waveMaterial.mainTextureOffset = new Vector2(Mathf.Sin(Time.time), Mathf.Sin(Time.time));
    }

    public float getWaveHeight(int x, int z)
    {
        waveMesh = GetComponent<MeshFilter>().mesh;
        waveVectors = waveMesh.vertices;
        Vector3 waveHeight = new Vector3();
        for(int i = 0; i < waveVectors.Length; i++)
        {
            waveHeight = transform.TransformPoint(waveVectors[i]);
            if(Mathf.RoundToInt(waveHeight.x) == x && Mathf.RoundToInt(waveHeight.z) == z)
            {
                return waveHeight.y;
            }
        }
        return 0;
    }

    public void onImpact(int x, int z)
    {

    }

    public bool inWaves(Transform other)
    {
        if(other.position.y < getWaveHeight(Mathf.RoundToInt(other.position.x), Mathf.RoundToInt(other.position.z)) + 2f)
        {
            return true;
        }
        else
        {
            return false;
        }
    }
}
